﻿/*
Название: StandardLinksNames.jsx
Приложение для использования: Adobe InDesign CS3, CS4, CS5
Версия: 1.1
Язык реализации (Среда): JavaScript (ExtendScript Toolkit 2)
Операционные системы (Платформы): PC, Macintosh (Windows, Mac OS)
Условия распространения: Бесплатно; На Ваш риск
Назначение: Переименование имен файлов (прилинкованных файлов и название документа) 
с нестандартными названиями. 
Данный скрипт допускает в качестве стандартных следующие символы: 
буквы латинского алфавита (английская раскладка), цифры (0-9)
и символы: нижнее подчеркивание "_" и дефис как минус "-".
Файлы со стандартными именами создаются как копии исходных файлов.
Исходные файлы могут быть удалены скриптом.
Техническая поддержка: Sergey-Anosov@yandex.ru
https://sites.google.com/site/dtpscripting
===================================================
Name: StandardLinksNames.jsx
Application to use with: Adobe InDesign CS3, CS4, CS5
Version: 1.1
Program language (Environment): JavaScript (ExtendScript Toolkit 2)
Operating systems (Platforms): PC, Macintosh (Windows, Mac OS)
Distribution conditions: Freeware; At your own risk
Functions: Renames file names (linked files and document name) 
which have non-standard symbols to standard named files.
This script allows as standard symbols the following: latin letters (English version),
figures (0-9), and  symbols: the Low Line "_" and the Hyphen-Minus "-".
It creates standard named files as copies of original files.
Original files could be deleted by the the script.
Technical support: Sergey-Anosov@yandex.ru
https://sites.google.com/site/dtpscripting
*/
//
// ***** ОСНОВНОЙ МОДУЛЬ
var AD; // акт. док-т
var D_NAME; // имя акт. докт-та
var D_NAME_ONLY;
var D_EXT;
var BAD_D_NAME = false;
var D_NEW_NAME;
var WAS_SAVED_OK = false;
var F_NAME = new Array(); // массив имен файлов
var F_PATH = new Array(); // массив путей файлов
var DOC_LINKS = new Array();; // ссылка на линки в док-те
var N_LINK; // общее кол-во линков в док-те
var N_REL = 0; // кол-во перелинкованных файлов
var N_FILES = 0; // общее кол-во файлов
var FS_N = 0; // выбранный номер файла
var EXIT_DIALOG = false; 
var SKIP_DIALOG = false; 
var N_SKIP = 0; // пропущено связей
var N_EMBEDDED = 0; // пропущено внедренных
var N_MISSING = 0; // пропущено потерянных
var N_EMB_FILES = 0; // внедр. файлов в док-те
var N_MIS_FILES = 0; // кол-во потерянных линков
var N_OUTD_FILES = 0; // кол-во потерянных линков
var WFS = false; // файловая система
var N_ERR = 0; // Количество ошибок
var BAD_FILES = new Array();
var BAD_FILE_NAME = new Array();
var BAD_FILE_NAME_ONLY = new Array();
var BAD_FILE_EXT = new Array();
var BAD_FILE_PATH = new Array();
var GOOD_FILE_NAME_ONLY = new Array();
var SHOW_NAME = new Array();
var GOOD_FILE_NAME;
var N_BAD_FILES = 0;
var BAD_NAME = false;
var BAD_SYM = false;
var SAME_NAME = false;
var EMPTY_NAME = false;
var DOC_PROC = false;
var NAMES_OK = false;
var DO_NOT_SAVE = false;
var DEL_ORIG = false;
var SLASH = "\\";
var TITLE = "StandardLinksNames v.1.1";
//
// начало выполнения
main();
//
// основной модуль
function main()
{
	CHECK_DOC();
	do 
	{
		DOC_PROC = false;
		NAMES_OK = false;
		// собираем информацию о линках
		LINKS_INFO();
		// запрос на сохранение документа
		if( !NAMES_OK )
		{
			SAVE_DOC_DIALOG();
		};// if
		if( EXIT_DIALOG ) break;
		// основной диалог
		if( !DIALOG_MAIN() ) exit();
		// проверяем выбрано ли для обработки имя документа
		if( BAD_D_NAME && ( FS_N == SHOW_NAME.length-1 ) )
		{
			DOC_PROC = true;
		};// if
		var BFN;// старое (плохое) имя файла
		var GFN;// новое (стандартизованное) имя файла
		var E;// расширение файла
		var P;// путь файла с именем
		var P_ONLY;// только путь файла без имени
		// если обрабатываются линки
		if( !DOC_PROC )
		{
			BFN = BAD_FILE_NAME_ONLY[ FS_N ];
			GFN = GOOD_FILE_NAME_ONLY[ FS_N ];
			E = BAD_FILE_EXT[ FS_N ];
			P = BAD_FILE_PATH[ FS_N ];
			P_ONLY = GET_PATH_ONLY( P, ( BFN + E ) );
		}
		// если обрабатывается имя документа
		else
		{
			var PATH_ERR = false;
			var DOC_FILE;
			// пытаемся получить ссылку на файл документа
			try
			{
				DOC_FILE  = File( AD.fullName );
			}
			// если ошибка считаем, что документу требуется сохранение
			catch( error )
			{
				PATH_ERR = true;
			};// try-catch
			// если произошла ошибка при получении на файл документа
			if( PATH_ERR )
			{
				var S_D_SAVE = 
				"The document must be saved"+"\n"+
				"before its name standardization!"+"\n\n"+
				"Save and continue?";
				// запрос на сохранение документа
				if( !confirm( S_D_SAVE ) )
				{
					continue;
				}
				else
				{
					try
					{
						AD.save();
					}
					catch( error )
					{
						alert("The document was not saved!");
						continue;
					};// try-catch
				};// if-else
				// получаем ссылку на файл после сохранения
				DOC_FILE  = File( AD.fullName );
				D_NAME = AD.name;
				D_NAME_ONLY = GET_EXT( D_NAME )[0];
				D_EXT = GET_EXT( D_NAME )[1];
				D_NEW_NAME = CHECK_NAME( D_NAME_ONLY );
				// если документ был сохранен со стандартным именем
				if( PATH_ERR && !BAD_NAME )
				{
					alert("The document was saved using standard name!");
					continue;
				};// if
			};// if
			BFN = D_NAME_ONLY;
			GFN = D_NEW_NAME;
			E = D_EXT;
			P = unescape( DOC_FILE.fsName );
			P_ONLY = GET_PATH_ONLY( P, ( BFN + E ) );
		};// if-else
		// заголовки для диалогов ввода нового имени
		var DIAL_TITLE = "Standardizing linked file name";
		if( DOC_PROC ) DIAL_TITLE = "Standardizing the document name";
		//
		// проверка полученного имени
		while( !EXIT_DIALOG || !SKIP_DIALOG )
		{
			// получаем новое имя из диалога
			var the_new_file_name = READ_NEW_FILE( DIAL_TITLE, BFN, GFN, E, P_ONLY );
			if( EXIT_DIALOG || SKIP_DIALOG ) break;
			// проверяем не пустое ли имя
			if( the_new_file_name == "" )
			{
				alert("File name can not be empty!\n"+
					   "Please enter a name!");
				continue;
			};// if
			// проверка существует ли такой файл
			var the_new_file_path_and_name = P_ONLY + SLASH + (the_new_file_name + E);
			var the_new_file = File( the_new_file_path_and_name );
			if( the_new_file.exists )
			{
				alert("File:\n"+ 
					   (the_new_file_name + E) + "\n"+
					   "exists at its folder already!\n"+
					   "Please enter another name!");
				continue;
			};// if
			// если все нормально выходим из цикла ввода имени
			break;
		};// end while
		// если полный выход из диалога то выход из скрипта
		if( EXIT_DIALOG ) break;
		// если пропускаем выбранный пункт то снова основной диалог
		if( SKIP_DIALOG ) continue;
		// стандартизированное имя файла
		GFN = the_new_file_name;
		// собственно выполнение 
		// если обрабатываются имена файлов линков
		if( !DOC_PROC ) OPERATION( (BFN+E), (GFN+E), P_ONLY )
		// если обрабатывается имя документа
		else
		{
			var DOC_STAND_ERR = false;
			var S = "Document name standardization report:\n\n";
			// ссыслка на файл документа с исправленным именем
			DOC_FILE  = File( P_ONLY + SLASH + (GFN + E) );
			try
			{
				// пересохраняем документ с исправленным именем
				AD = AD.save( DOC_FILE );
				// если была команда на удаление оригинала то удаляем оригинал
				if( DEL_ORIG )
				{
					var DEL_ERR = false;
					try
					{
						// ссылка на исходный файл
						var DOC_TO_DEL = File( P_ONLY + SLASH + (BFN+E) );
						DEL_ERR =  !( DOC_TO_DEL.remove() );
					}
					catch( error )
					{
						DEL_ERR = true;
					};// try-catch
				};// if
				S = S + "Original (non-standard) file name:\n"+(BFN+E)+"\n";
				if( DEL_ORIG && !DEL_ERR ) S = S + "[Original document file was deleted]\n";
				S = S +  "\n";
				S = S + "Standardized file name:\n"+(GFN+E);
			} 
			catch (error )
			{
				DOC_STAND_ERR = true;
			};// try-catch
			if( DOC_STAND_ERR ) S = S + "There was an error occured\nduring the document name standardizing!";
			alert( S );
		};// if
	} 
	while (!EXIT_DIALOG);	
	exit();
};// end main
//
// подпрограмма собственно замены нестандартных имен
function OPERATION( BFN, GFN, P )
{
	// пропущено внедренных
	var N_EMBEDDED = 0;
	// пропущено потерянных
	var N_MISSING = 0;
	// кол-во ошибок
	var N_ERR = 0;
	// собственно количество замен
	var N_REL = 0;
	// сначала пересохраняем файл с нестандартным именем
	// как стандартный
	// обозначаем старый файл
	var OLD_FILE_NAME = P + SLASH + BFN;
	var OLD_FILE = File( OLD_FILE_NAME );
	// новое имя и путь файла
	var NEW_FILE_NAME = P + SLASH + GFN;
	// копируем старый файл в новый файл
	try
	{
		var NEW_FILE = OLD_FILE.copy( NEW_FILE_NAME );
		NEW_FILE = File( NEW_FILE_NAME );
	} catch ( error ) {};
	// цикл по всем линкам в документе
	for( var i = N_LINK-1; i >= 0; i-- )
	{
		var L_i = DOC_LINKS[i];
		var FP_i = L_i.filePath;
		var F_i = File( FP_i );
		F_i = unescape( F_i.fsName );
		if( F_i == OLD_FILE_NAME )
		{
			try
			{
				// пропускаем если внедренный линк
				if( L_i.status == 1282237028 ) 
				{
					N_EMBEDDED++;
					continue;
				};// if
				// пропускаем если потерянный линк
				if( L_i.status == 1819109747 ) 
				{
					N_MISSING++;
					continue;
				};// if
				L_i.relink( NEW_FILE );
				L_i.update();
				N_REL++;
			}
			catch ( error )
			{
				N_ERR++;
			};// try-catch
		};// if
	};// for
	var DEL_ERR = false;
	// если дана команда удалить оригинал
	if( DEL_ORIG )
	{
		try
		{
			DEL_ERR =  !( OLD_FILE.remove() );
		}
		catch ( error )
		{
			N_ERR++;
			DEL_ERR = true;
		};// try-catch
	};// if
	//
	// выводим сообщение о выполнении
	if( DOC_PROC ) var WHAT = "Document file name "
	else var WHAT = "Linked file name ";
	var S = WHAT+"standardization report:\n\n";
	S = S + "Original (non-standard) file name:\n"+BFN+"\n";
	if( DEL_ORIG && !DEL_ERR) S = S + "[Original file was deleted]\n";
	S = S + "\n";
	S = S + "Standardized file name:\n"+GFN+"\n\n";
	S = S + "Links standardized: "+N_REL+"\n";
	if( N_EMBEDDED > 0 ) S = S + "Embedded links skipped: "+N_EMBEDDED+"\n";
	if( N_MISSING > 0 ) S = S + "Missing links skipped: "+N_MISSING+"\n";
	if( N_ERR > 0 ) S = S + "Operation errors: "+N_ERR+"\n";
	alert( S );
	return;
};// end OPERATION
//
// ***** ПОДПРОГРАММА ВВОДА НОВОГО ИМЕНИ ФАЙЛА
function READ_NEW_FILE( WHAT, OLD_NAME, NEW_NAME, EXT, PATH ) 
{
	EXIT_DIALOG = false;
	SKIP_DIALOG = false; 
	DEL_ORIG = false;
	var the_new_file_name_ini = NEW_NAME;
	var NEW_FILE_DIALOG = new Window('dialog');
	NEW_FILE_DIALOG.text = TITLE;
	NEW_FILE_DIALOG.childrenAlignment = 'center';
	// основная панель
	var mp = NEW_FILE_DIALOG.add('panel');
	mp.text = WHAT;
	mp.alignChildren = 'left';
	if( WFS ) var TEXT_PAN_LEN = 240 else var TEXT_PAN_LEN = 273;
	// панель со старым именем
	var OLD_NAME_PAN = mp.add('panel');
	OLD_NAME_PAN.text = "Original file name:";
	OLD_NAME_TXT = OLD_NAME_PAN.add('edittext', undefined, "", {multiline: true, readonly: true} );
	OLD_NAME_TXT.maximumSize.width =
	OLD_NAME_TXT.minimumSize.width = TEXT_PAN_LEN;
	OLD_NAME_TXT.text = OLD_NAME;
	// панель с новым именем
	var NEW_NAME_PAN = mp.add('panel');
	NEW_NAME_PAN.text = "New (standardized) file name:";
	var NEW_NAME_TXT = NEW_NAME_PAN.add('edittext', undefined, "", {multiline: true, readonly: false} );
	NEW_NAME_TXT.maximumSize.width =
	NEW_NAME_TXT.minimumSize.width = TEXT_PAN_LEN;
	NEW_NAME_TXT.text = NEW_NAME;
	NEW_NAME_TXT.onChanging = NEW_FILE_INPUT;
	NEW_NAME_TXT .active = true;
	// панель с расширением
	var EXT_PAN = mp.add('panel');
	EXT_PAN.text = "File extension:";
	var EXT_TXT = EXT_PAN.add('edittext', undefined, "", {multiline: true, readonly: true} );
	EXT_TXT.maximumSize.width =
	EXT_TXT.minimumSize.width = TEXT_PAN_LEN;
	EXT_TXT.text = EXT;
	// панель с путем файла
	var PATH_PAN = mp.add('panel');
	PATH_PAN.text = "File path:";
	var PATH_TXT = PATH_PAN.add('edittext', undefined, "", {multiline: true, readonly: true} );
	PATH_TXT.maximumSize.width =
	PATH_TXT.minimumSize.width = TEXT_PAN_LEN;
	PATH_TXT.text = PATH;
	// запрос на удаление исходного (нестандартного) файла
	var DEL = mp.add('checkbox');
	DEL.text = "Delete original file after standardizing";
	DEL.value = false;
	DEL.onClick = function ()
	{
		if( DEL.value && !confirm("Are you sure?") )
		{
			 DEL.value = false;
		};// if
		return;
	};// end DEL.onClick
	// группа кнопок внизу
	var BG = NEW_FILE_DIALOG.add('group');
	BG.orientation = 'row';
	BG.childrenAlignment = 'center';
	var okBtn = BG.add('button', undefined, 'OK');// кнопка ОК
	var skipBtn = BG.add('button', undefined, 'Skip');// кнопка Skip
	var exitBtn = BG.add('button', undefined, 'Exit');// кнопка Exit
	NEW_FILE_DIALOG.defaultElement = okBtn;
	NEW_FILE_DIALOG.cancelElement = skipBtn;
	exitBtn.onClick = function ()
	{
		NEW_FILE_DIALOG.close();
		EXIT_DIALOG = true;
	};// end exitBtn.onClick
	//
	// подпрограмма проверки ввода нового имени файла
	function NEW_FILE_INPUT()
	{
		CHECK_NAME( NEW_NAME_TXT.text );
		if( BAD_NAME )
		{
			alert( "Non-standard symbol(s) input!\n\n" +
					"Please type latin letters (English version),\n"+
					"figures (0-9) and symbols _ and -"
			);
			NEW_NAME_TXT.text = NEW_NAME;
		};// if
		return;		
	};// end NEW_FILE_INPUT
	//
	// собственно показываем диалог
	var DIALOG_BUTTON = NEW_FILE_DIALOG.show();
	// нажато ОК
	if( DIALOG_BUTTON == 1 )
	{
		EXIT_DIALOG = false;
		SKIP_DIALOG = false;
		DEL_ORIG = DEL.value;
	};// if
	// нажато Skip
	if( DIALOG_BUTTON == 2 )
	{
		SKIP_DIALOG = true;
	};// if
	return NEW_NAME_TXT.text;
};// end READ_NEW_FILE
//
// ***** ПОДПРОГРАММА СБОРА ИНФ. О ЛИНКАХ
function LINKS_INFO() 
{
	GET_DOC_INFO();
	// очищаем все массивы
	BAD_FILE_NAME = BAD_FILE_NAME.slice(0, 0);
	BAD_FILE_PATH = BAD_FILE_PATH.slice(0, 0);
	BAD_FILE_NAME = BAD_FILE_NAME.slice(0, 0);
	BAD_FILE_EXT = BAD_FILE_EXT.slice(0, 0);
	GOOD_FILE_NAME_ONLY = GOOD_FILE_NAME_ONLY.slice(0, 0);
	BAD_FILE_NAME_ONLY = BAD_FILE_NAME_ONLY.slice(0, 0);
	SHOW_NAME = SHOW_NAME.slice(0, 0);
	// начальная обработка инф. о линках
	// формирование массивов  F_NAME и F_PATH инф. о файлах
	// и общее кол-во залинкованных файлов N_FILES
	// 
	// массив уникальных файлов в документе
	var UNIQ = new Array();
	DOC_LINKS = AD.links;
	UNIQ = UNIQ_LINK_NAMES( DOC_LINKS );
	// массив уникальных путей
	F_PATH = UNIQ[0];
	// массив уникальных имен
	F_NAME = UNIQ[1];
	// количество залинкованных файлов
	N_FILES = F_PATH.length;
	//
	// среди уникальных имен файлов ищем нестандартные
	for( var i=0; i < N_FILES; i++ )
	{
		var FN_i = F_NAME[i];
		// получаем отдельно имя и расширение файла
		var name_and_ext_i = new Array();
		name_and_ext_i = GET_EXT( FN_i );
		// только имя
		var NAME_ONLY_i = name_and_ext_i[0];
		// расширение
		var EXT_i = name_and_ext_i[1];
		// собственно проверяем правильность имени файла (без расширения)
		var F_NEW_NAME_i = CHECK_NAME( NAME_ONLY_i );
		if( BAD_NAME )
		{
			BAD_FILE_NAME.push( FN_i );
			BAD_FILE_PATH.push( F_PATH[i] );
			BAD_FILE_NAME_ONLY.push( NAME_ONLY_i );
			BAD_FILE_EXT.push( EXT_i );
			GOOD_FILE_NAME_ONLY.push( F_NEW_NAME_i );
		};// if
	};// for
	SHOW_NAME = ARR_TO_SHOW( BAD_FILE_NAME, BAD_FILE_PATH );
	N_BAD_FILES = BAD_FILE_NAME.length;
	// проверяем имя документа
	BAD_D_NAME = false;
	name_and_ext_i = GET_EXT( D_NAME );
	D_NAME_ONLY = name_and_ext_i[0];
	D_EXT = name_and_ext_i[1];
	D_NEW_NAME = CHECK_NAME( D_NAME_ONLY );
	if( BAD_NAME ) 
	{
		BAD_D_NAME = true;
		SHOW_NAME.push(D_NAME+" [the document name]");
	};// if
	NAMES_OK = false;
	if( SHOW_NAME.length == 0 ) NAMES_OK = true;
	return;
};// LINKS_INFO
//
// ***** ПОДПРОГРАММА ОТОБРАЖЕНИЯ начального ДИАЛОГА
function DIALOG_MAIN() 
{
	dlg = new Window('dialog');
	dlg.text = TITLE;
	// основная панель
	var mp = dlg.add('panel');
	mp.alignChildren = 'left';
	//
	function REFILL_DROP( d, arr, ini )
	{
		for( var i=d.items.length; i >= 0; i-- )
		{
			try
			{
				d.remove(  d.items[i]  );
			} catch ( error ) {};
		};// for
		for( var i=0; i < arr.length; i++ ) d.add( 'item', arr[i] );
		d.selection = ini;
		return;
	};// end REFILL_DROP
	//
	function TEXT( txt )
	{
		var t = mp.add('statictext');
		t.text = txt;
		return t;
	};// end TEXT
	//
	function CB( ini, txt )
	{
		var c = mp.add('checkbox');
		c.text = txt;
		c.value = ini;
		return c;
	};// end CB
	//
	function DD( arr, ini )
	{
		var d = mp.add('dropdownlist');
		for( var i=0; i<arr.length; i++ ) d.add('item', arr[i] );
		d.selection = ini;
		return d;
	};// end DD
	//
	TEXT( "Document name: " );
	if( WFS ) var DNL = 240 else var DNL = 273;
	var DOC_NAME_TXT = mp.add('edittext', undefined, "", {multiline: true, readonly: true} );
	DOC_NAME_TXT.text = D_NAME;
	DOC_NAME_TXT.maximumSize.width =
	DOC_NAME_TXT.minimumSize.width = DNL;
	if( BAD_D_NAME ) TEXT( "The document name is non-standard!" );
	TEXT( "Links in the document: "+N_LINK );
	var WILL_NOT_PROC = " [Will not be processed!]";
	if( NAMES_OK ) WILL_NOT_PROC = "";
	if (N_EMB_FILES > 0) 
	{
		TEXT( "Embedded links: " + N_EMB_FILES + WILL_NOT_PROC );
	};// if
	if (N_MIS_FILES > 0) 
	{
		TEXT( "Missing links: " + N_MIS_FILES + WILL_NOT_PROC );
	};// if
	if (N_OUTD_FILES > 0) 
	{
		TEXT( "Outdated links: " + N_OUTD_FILES );
	};// if
	if( N_LINK > 0 )
	{
		TEXT( "Linked files in the document: " + N_FILES);
	};// if
	if( N_BAD_FILES > 0)
	{
		TEXT( "Non-standard named linked files: " + N_BAD_FILES );
	};// if
	if( !NAMES_OK )
	{
		TEXT( "Name(s) to be standardized: ");
		var SELECTED_FILE = DD( SHOW_NAME, 0 );
		SELECTED_FILE.maximumSize.width = 
		SELECTED_FILE.minimumSize.width = DNL;
	}
	else
	{
		
		TEXT("Name(s) to be standardized: Not detected");
	};// if-else
	//
	// подпрограмма деактивации / активации списка
	function DROP_ACTIVE_DEACTIVE( the_drop, act ) 
	{
		var NA;
		if( !act ) 
		{
			if( !the_drop.enabled ) return;
			NA = the_drop.add('item', "N/A");
			NA.selected = true;
			the_drop.enabled = false;
		} 
		else 
		{
			try 
			{
				if( the_drop.enabled ) return;
				the_drop.remove(  the_drop.items[the_drop.items.length-1]  );
				the_drop.items[0].selected = true;
				the_drop.enabled = true;
			} catch ( error ) {};
		};// if
		return;
	};// end DROP_ACTIVE_DEACTIVE
	//
	// создание панели кнопок (кнопка ОК, кнопка Cancel)
	var okPanel, okBtn, cancelBtn;
	okPanel = dlg.add('group');
	okPanel.orientation = 'row';
	if( !NAMES_OK )
	{
		okBtn = okPanel.add('button', undefined, 'OK');// кнопка ОК
		dlg.defaultElement = okBtn;
	};// if
	cancelBtn = okPanel.add('button', undefined, 'Exit');// кнопка Cancel
	dlg.cancelElement = cancelBtn;
	// собственно показываем окно диалога
	var DIALOG_BUTTON = dlg.show();
	// если нажали ОК
	if (DIALOG_BUTTON == 1) 
	{
		if(  !NAMES_OK )
		{
			FS_N = SELECTED_FILE.selection.index;
			return true;
		}
		else
		{
			return false;
		};// if-else
	};// if OK
	// если нажали Exit
	if (DIALOG_BUTTON == 2) return false;
};// end DIALOG_MAIN
//
//
// ***** ПОДПРОГРАММА ИСПРАВЛЕНИЯ ПУТИ
// ***** убираем двоеточия для МАКа (для отображения в диалоге)
function FIX_PATH(p) 
{
	if( WFS ) return p;
	fp = "";
	for( var i=0; i < p.length; i++ )
	{
		var p_i = p[i];
		if( p_i == ":" )
		{
			fp = fp + "/";
			continue;
		};// if
		fp = fp + p_i;
	};// for
	return fp;
};// end FIX_PATH
//
// подпрограмма получения уникальных имен и путей
// для выяснения сколько уникальных файлов залинковано
function UNIQ_LINK_NAMES( arr_in)
{
	N_EMB_FILES = 0;
	N_MIS_FILES = 0;
	N_OUTD_FILES = 0;
	var arr = new Array();
	arr = arr_in;
	var ret_path = new Array();
	var ret_name = new Array();
	for( var i = 0; i < arr.length; i++ )
	{
		var arr_i = arr[i];
		try
		{
			var f_i = new File( arr_i.filePath );
			var path_i = unescape( f_i.fsName );
			var name_i = unescape( arr_i.name );
		}
		catch ( error )
		{
			continue;
		};
		if( arr_i.status == 1282237028 ) N_EMB_FILES++;
		if( arr_i.status == 1819109747 ) N_MIS_FILES++;
		if( arr_i.status == 1819242340 ) N_OUTD_FILES++;
		var uniq = true;
		for( var j = 0; j < ret_path.length; j++ )
		{
			var ret_path_j = ret_path[j];
			if( path_i == ret_path_j )
			{
				uniq = false;
				break;
			};// if
		};// for j
		if( uniq ) 
		{
			ret_path.push( path_i );
			ret_name.push( name_i );
		};// if
	};// for i
	return [ ret_path, ret_name ];
};// end UNIQ_PATHS_NAMES
//
// подпрограмма создания массива для отображения в диалоге
function ARR_TO_SHOW( name, path )
{
	var arr = new Array();
	for( var i=0; i < path.length; i++ )
	{
		arr[i] = unescape( name[i] ) + " >> " + unescape( FIX_PATH( unescape( path[i] ) ) );
	};// for
	return arr;
};// end LIST_TO_SHOW
//
// подпрограмма проверки символа
function CHECK_SYM( C )
{
	// если символ стандартный
	BAD_SYM = false; 
	if( C == "A" || C == "a" || 
		C == "B" || C == "b" || 
		C == "C" || C == "c" || 
		C == "D" || C == "d" || 
		C == "E" || C == "e" || 
		C == "F" || C == "f" || 
		C == "G" || C == "g" || 
		C == "H" || C == "h" || 
		C == "I" || C == "i" || 
		C == "J" || C == "j" || 
		C == "K" || C == "k" || 
		C == "L" || C == "l" || 
		C == "M" || C == "m" || 
		C == "N" || C == "n" || 
		C == "O" || C == "o" || 
		C == "P" || C == "p" || 
		C == "Q" || C == "q" || 
		C == "R" || C == "r" || 
		C == "S" || C == "s" || 
		C == "T" || C == "t" || 
		C == "U" || C == "u" || 
		C == "V" || C == "v" || 
		C == "W" || C == "v" || 
		C == "X" || C == "x" || 
		C == "Y" || C == "y" || 
		C == "Z" || C == "z" || 
		C == "-" || C == "_" || 
		C == "0" || C == "1" || 
		C == "2" || C == "3" || 
		C == "4" || C == "5" || 
		C == "6" || C == "7" || 
		C == "8" || C == "9" ) { return C };
		// 
		// замена настандартных символов
		 BAD_SYM = true; 
		 //
		// кириллица (русские буквы)
		if( C == "А" || C == "а" ) { return "a" };
		if( C == "Б" || C == "б" ) { return "b" };
		if( C == "В" || C == "в" ) { return "v" };
		if( C == "Г" || C == "г" ) { return "g" };
		if( C == "Д" || C == "д" ) { return "d" };
		if( C == "Е" || C == "е" ) { return "e" };
		if( C == "Ё" || C == "ё" ) { return "e" };
		if( C == "Ж" || C == "ж" ) { return "zh" };
		if( C == "З" || C == "з" ) { return "z" };
		if( C == "И" || C == "и" ) { return "i" };
		if( C == "Й" || C == "й" ) { return "i" };
		if( C == "Ы" || C == "ы" ) { return "y" };
		if( C == "К" || C == "к" ) { return "k" };
		if( C == "Л" || C == "л" ) { return "l" };
		if( C == "М" || C == "м" ) { return "m" };
		if( C == "Н" || C == "н" ) { return "n" };
		if( C == "О" || C == "о" ) { return "o" };
		if( C == "П" || C == "п" ) { return "p" };
		if( C == "Р" || C == "р" ) { return "r" };
		if( C == "С" || C == "с" ) { return "s" };
		if( C == "Т" || C == "т" ) { return "t" };
		if( C == "У" || C == "у" ) { return "u" };
		if( C == "Ф" || C == "ф" ) { return "f" };
		if( C == "Х" || C == "х" ) { return "h" };
		if( C == "Ц" || C == "ц" ) { return "ts" };
		if( C == "Ч" || C == "ч" ) { return "ch" };
		if( C == "Ш" || C == "ш" ) { return "sh" };
		if( C == "Щ" || C == "щ" ) { return "sh" };
		if( C == "Ъ" || C == "ъ" ) { return "" };
		if( C == "Ь" || C == "ь" ) { return "" };
		if( C == "Э" || C == "э" ) { return "e" };
		if( C == "Ю" || C == "ю" ) { return "yu" };
		if( C == "Я" || C == "я" ) { return "ya" };
		 //
		// замена нестандартного A
		if( C == "À" || C == "à" || 
			C == "Á" || C == "á" || 
			C == "Â" || C == "â" || 
			C == "Ã" || C == "ã" || 
			C == "Ä" || C == "ä" || 
			C == "Å" || C == "å" || 
			C == "Æ" || C == "æ" || 
			C == "Ā" || C == "ā" || 
			C == "Ă" || C == "ă" || 
			C == "Ą" || C == "ą" || 
			C == String.fromCharCode (0x01CD) || C ==  String.fromCharCode (0x01CE) || 
			C == "Ǻ" || C == "ǻ" || 
			C == "Ǽ" || C == "ǽ" || 
			C == "А" || C == "а" ||
			C == "Ạ" || C == "ạ" ||
			C == "Ả" || C == "ả" ||
			C == "Ấ" || C == "ấ" ||
			C == "Ầ" || C == "ầ" ||
			C == "Ẩ" || C == "ẩ" ||
			C == "Ẫ" || C == "ẫ" ||
			C == "Ậ" || C == "ậ" ||
			C == "Ắ" || C == "ắ" ||
			C == "Ằ" || C == "ằ" ||
			C == "Ẳ" || C == "ẳ" ||
			C == "Ẵ" || C == "ẵ" ||
			C == "Ặ" || C == "ặ" ||
			C == "Α" || C == "α" ||
			C == "Ά" || C == "ά") { return "a" };
		//
		// замена нестандартного E
		if( C == "È" || C == "è" || 
			C == "É" || C == "é" || 
			C == "Ê" || C == "ê" || 
			C == "Ë" || C == "ë" || 
			C == "Ē" || C == "ē" || 
			C == "Ĕ" || C == "ĕ" || 
			C == "Ė" || C == "ė" || 
			C == "Ę" || C == "ę" || 
			C == "Ě" || C == "ě" || 
			C == "Ẹ" || C == "ẹ" || 
			C == "Ẹ" || C == "ẹ" || 
			C == "Ẻ" || C == "ẻ" || 
			C == "Ẽ" || C == "ẽ" || 
			C == "Ế" || C == "ế" || 
			C == "Ề" || C == "ề" || 
			C == "Ể" || C == "ể" || 
			C == "Ễ" || C == "ễ" || 
			C == "Ệ" || C == "ệ" || 
			C == "Έ" || C == "έ" ||
			C == "Ε" || C == "ε" ||
			C == "Ή" || C == "ή" ||
			C == "Η" || C == "η" ||
			C == "Ə" || C == "ə" )  { return "e" };
		//
		// замена нестандартного I
		if( C == "Ì" || C == "ì" || 
			C == "Í" || C == "í" || 
			C == "Î" || C == "î" || 
			C == "Ï" || C == "ï" || 
			C == "Ĩ" || C == "ĩ" || 
			C == "Ī" || C == "ī" || 
			C == "Ĭ" || C == "ĭ" || 
			C == "Į" || C == "į" || 
			C == "İ" || C == "ı" ||
			C == "Ĳ" || C == "ĳ" ||
			C == "Ĵ" || C == "ĵ" ||
			C == String.fromCharCode (0x01CF) || C ==  String.fromCharCode (0x01D0) || 
			C == "І" || C == "і" ||
			C == "Ї" || C == "ї" ||
			C == "Ј" || C == "ј" ||
			C == "Ỉ" || C == "ỉ" ||
			C == "Ị" || C == "ị" ||
			C.toLowerCase() == "ΐ" ||
			C == "Ι" || C == "ι" ||
			C == "Ϊ" || C == "ϊ" ||
			C.toLowerCase() == "ί" ||
			C.toLowerCase() == "Ί" )  { return "i" };
		//
		// замена нестандартного O
		if( C == "Ọ" || C == "ọ" || 
			C == "Ỏ" || C == "ỏ" || 
			C == "Ố" || C == "ố" || 
			C == "Ồ" || C == "ồ" || 
			C == "Ổ" || C == "ổ" || 
			C == "Ỗ" || C == "ỗ" || 
			C == "Ộ" || C == "ộ" || 
			C == "Ớ" || C == "ớ" || 
			C == "Ờ" || C == "ờ" || 
			C == "Ỡ" || C == "ỡ" || 
			C == "Ợ" || C == "ợ" || 
			C == "Ò" || C == "ò" || 
			C == "Ó" || C == "ó" || 
			C == "Ô" || C == "ô" || 
			C == "Õ" || C == "õ" || 
			C == "Ö" || C == "ö" || 
			C == "Ø" || C == "ø" || 
			C == "Ө" || C == "ө" || 
			C == "Ō" || C == "ō" || 
			C == "Ŏ" || C == "ŏ" || 
			C == "Ő" || C == "ő" || 
			C == "Œ" || C == "œ" || 
			C == "Ơ" || C == "ơ" || 
			C == String.fromCharCode (0x01D1) || C ==  String.fromCharCode (0x01D2) || 
			C == "Ǿ" || C == "ǿ" || 
			C == "Ό" || C == "ό"||
			C == "Ώ" || C == "ώ" ||
			C == "Ω" || C == "ω" ||
			C == "Ο" || C == "ο" )  { return "o" };
		//
		// замена нестандартного U
		if( C == "Ù" || C == "ù" || 
			C == "Ú" || C == "ú" || 
			C == "Û" || C == "û" || 
			C == "Ü" || C == "ü" || 
			C == "Ũ" || C == "ũ" || 
			C == "Ū" || C == "ū" || 
			C == "Ŭ" || C == "ŭ" || 
			C == "Ů" || C == "ů" || 
			C == "Ű" || C == "ű" || 
			C == "Ų" || C == "ų" || 
			C == "Ư" || C == "ư" || 
			C == String.fromCharCode (0x01D3) || C ==  String.fromCharCode (0x01D4) || 
			C == String.fromCharCode (0x01D5) || C ==  String.fromCharCode (0x01D6) || 
			C == String.fromCharCode (0x01D7) || C ==  String.fromCharCode (0x01D8) || 
			C == String.fromCharCode (0x01D9) || C ==  String.fromCharCode (0x01DA) || 
			C == String.fromCharCode (0x01DB) || C ==  String.fromCharCode (0x01DC) || 
			C == "Ụ" || C == "ụ" || 
			C == "Ủ" || C == "ủ" || 
			C == "Ứ" || C == "ứ" || 
			C == "Ừ" || C == "ừ" || 
			C == "Ử" || C == "ử" || 
			C == "Ữ" || C == "ữ" || 
			C == "Ύ" || C == "ύ" || 
			C == "Ϋ" || C == "ϋ" ||
			C == "Υ" || C == "υ" ||
			C.toLowerCase() == "ΰ" ||
			C == "Ự" || C == "ự" ) { return "u" };
		//
		// замена нестандартного C
		if( C == "Ç" || C == "ç" || 
			C == "Ć" || C == "ć" || 
			C == "Ĉ" || C == "ĉ" || 
			C == "Ċ" || C == "ċ" || 
			C == "Č" || C == "č" ) { return "c" };
		//
		// замена нестандартного D
		if( C == "Ď" || C == "ď" || 
			C == "Đ" || C == "đ" ) { return "d" };
		if( C == "Ð" || C == "ð" ) { return "th" };
		if( C == "Ђ" || C == "ђ" ) { return "dzh" };
		//
		// замена нестандартного G
		if( C == "Ĝ" || C == "ĝ" || 
			C == "Ğ" || C == "ğ" ||
			C == "Ġ" || C == "ġ" ||
			C == "Ģ" || C == "ģ" ||
			C == "Ѓ" || C == "ѓ" ||
			C == "Γ" || C == "γ" ) { return "g" };
		//
		// замена нестандартного W
		if( C == "Ẁ" || C == "ẁ" || 
			C == "Ẃ" || C == "ẃ" ||
			C == "Ẅ" || C == "ẅ" ||
			C == "Ŵ" || C == "ŵ" ) { return "w" };
		//
		// замена нестандартного Y
		if( C == "Ỳ" || C == "ỳ" || 
			C == "Ỵ" || C == "ỵ" ||
			C == "Ỷ" || C == "ỷ" ||
			C == "Ỹ" || C == "ỹ" ||
			C == "Ý" || C == "ý" ||
			C == "Ŷ" || C == "ŷ" ||
			C == "Ÿ" || C == "ÿ" ) { return "y" };
		if( C == "Ү" || C == "ү" || 
			C == "Ұ" || C == "ұ" ) { return "u" };
		//
		// замена нестандартного L
		if( C == "Ĺ" || C == "ĺ" || 
			C == "Ļ" || C == "ļ" ||
			C == "Ľ" || C == "ľ" ||
			C == "Ŀ" || C == "ŀ" ||
			C == "Ł" || C == "ł" ||
			C == "Λ" || C == "λ" ) { return "l" };
		//
		// замена нестандартного S
		if( C == "Ś" || C == "ś" || 
			C == "Ŝ" || C == "ŝ" ||
			C == "Ş" || C == "ş" ||
			C == "Š" || C == "š" ||
			C == "Ѕ" || C == "ѕ" ||
			C == "ς" || C == "σ" ||
			C == "Σ"  || C == "ſ") { return "s" };
			if( C.toLowerCase() == "ß" ) { return "ss" };
		//
		// замена нестандартного N
		if( C == "Ń" || C == "ń" || 
			C == "Ņ" || C == "ņ" ||
			C == "Ň" || C == "ň" ||
			C == "Ν" || C == "ν" ||
			C == "ŉ" ) { return "n" };
		if( C == "Ŋ" || C == "ŋ" ) { return "ng" };
		//
		// замена нестандартного R
		if( C == "Ŕ" || C == "ŕ" || 
			C == "Ŗ" || C == "ŗ" ||
			C == "Ř" || C == "ř" ||
			C == "Ρ" || C == "ρ" ) { return "r" };
		//
		// замена нестандартного T
		if( C == "Ţ" || C == "ţ" || 
			C == "Ť" || C == "ť" ||
			C == "Ŧ" || C == "ŧ" ||
			C == "Τ" || C == "τ" ||
			C == "Θ" || C == "θ" ||
			C == "Т" || C == "т"  ) { return "t" };
		//
		// замена нестандартного H
		if( C == "Ĥ" || C == "ĥ" || 
			C == "Ħ" || C == "ħ" ||
			C == "Χ" || C == "χ" )  { return "h" };
		if( C == "Ξ" || C == "ξ" )  { return "x" };
		if( C == "Һ" || C == "һ" )  { return "sh" };
		//
		// замена нестандартного K
		if( C == "Ķ" || C == "ķ" || 
			C.toLowerCase() == "ĸ" ||
			C == "Ќ" || C == "ќ" ||
			C == "Κ" || C == "κ" ||
			C == "К" || C == "к" )  { return "k" };
		//
		// замена нестандартного F
		if( C == "Φ" || C == "φ" || 
			C == "Ф" || C == "ф" ||
			C.toLowerCase() == "ƒ" )  { return "f" };
		//
		// замена оставшихся греческих букв
		if( C == "Β" || C == "β" )  { return "b" };
		if( C == "Δ" || C == "δ" )  { return "d" };
		if( C == "Ζ" || C == "ζ" )  { return "z" };
		if( C == "Μ" || C == "μ" )  { return "m" };
		if( C == "Π" || C == "π" )  { return "p" };
		if( C == "Ψ" || C == "ψ" )  { return "p" };
		//
		// нижнее подчеркивание для замены всего остального
		return "_";
};// end CHECK_SYM
//
//
// подпрограмма проверки и замены (при необходимости)
// имени файла
function CHECK_NAME( N )
{
	BAD_SYM = false;
	var N_OUT = "";
	BAD_NAME = false;
	// цикл по символам имени
	for( var i=0; i < N.length; i++)
	{
		var C_i = CHECK_SYM( N[i] );
		N_OUT = N_OUT + C_i;
		// если хотя бы один символ нестандартный считаем все имя нестандартным
		if( BAD_SYM ) BAD_NAME = true;
	};// for i
	// если имя нестандартное
	if( BAD_NAME )
	{
		// если стандартизрванное имя вдруг оказалось пустым
		if( N_OUT == "" ) N_OUT = "_";
		return N_OUT.toLowerCase();
	}
	// если имя стандартное 
	else return N_OUT;
};// end CHECK_NAME
//
// подпрограмма получения расширения файла и имени без расширения
function GET_EXT( N )
{
	// расширение на выходе
	var EXT = "";
	// только имя без расширения на выходе
	var N_ONLY = "";
	var STOP_EXT = false;
	// цикл по символам начиная с последнего
	for( var i = N.length-1; i >= 0; i-- )
	{
		var N_i = N[i];
		if( !STOP_EXT )
		{
			EXT = N_i + EXT;
			if( N_i == "." ) STOP_EXT = true;
			continue;
		};// if
		N_ONLY = N_i + N_ONLY;
	};// for
	return [ N_ONLY, EXT ];	
};// end GET_EXT
//
// подпрограмма начально проверки документа
// в том числе выяснения открыт ли он вообще
function CHECK_DOC()
{
	if(File.fs == "Windows") WFS = true; // определяем файловую систему
	if( app.documents.length == 0 )
	{
		alert("There are no open documents!");
		exit();
	};// if
	// если файловая система не Windows переназначаем символ косой черты для имен и путей
	if(!WFS) SLASH = "/";
	GET_DOC_INFO();
	return;
};// end CHECK_DOC
//
// подпрограмма получения только пути файла
// FP - путь с именем
// FN - только имя
function GET_PATH_ONLY( FP, FN )
{
	try
	{
		var N = FN.length+1;
		var L = FP.length;
		var P = FP.substr( 0, ( L - N ) );
	} catch ( error ) {};// try-catch
	return P
};// end GET_PATH_ONLY
//
// подпрограмма получения информации о документе
function GET_DOC_INFO()
{
	AD = app.activeDocument;
	D_NAME = AD.name;
	DOC_LINKS = AD.links;
	N_LINK = DOC_LINKS.length;
	return;
};// end GET_DOC_INFO
//
// подпрограмма сохранения файла перед выполненим скрипта
function SAVE_DOC_DIALOG()
{
	if( DO_NOT_SAVE ) return;
	WAS_SAVED_OK = false;
	var D_SAVE = false;
	if( !NAMES_OK )
	{
		D_SAVE = confirm("Save the document before operation?" );
	};// if
	if( D_SAVE )
	{
		try 
		{
			AD.save();
			WAS_SAVED_OK = true;
		} 
		catch( error ) 
		{ 
			WAS_SAVED_OK = false;
		};// try-catch
		if( D_SAVE && !WAS_SAVED_OK ) 
		{
			if( !confirm("The document was not saved!\nContinue?") ) EXIT_DIALOG = true;
		};// if
	};// if
	DO_NOT_SAVE = true;
	return;
};// end SAVE_DOC_DIALOG